// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDecayFunction1DGauss.pypp.h"

namespace bp = boost::python;

struct FTDecayFunction1DGauss_wrapper : FTDecayFunction1DGauss, bp::wrapper< FTDecayFunction1DGauss > {

    FTDecayFunction1DGauss_wrapper(FTDecayFunction1DGauss const & arg )
    : FTDecayFunction1DGauss( arg )
      , bp::wrapper< FTDecayFunction1DGauss >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDecayFunction1DGauss_wrapper(double omega )
    : FTDecayFunction1DGauss( omega )
      , bp::wrapper< FTDecayFunction1DGauss >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDecayFunction1DGauss * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDecayFunction1DGauss::clone(  );
        }
    }
    
    ::FTDecayFunction1DGauss * default_clone(  ) const  {
        return FTDecayFunction1DGauss::clone( );
    }

    virtual double evaluate( double q ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( q );
        else{
            return this->FTDecayFunction1DGauss::evaluate( q );
        }
    }
    
    double default_evaluate( double q ) const  {
        return FTDecayFunction1DGauss::evaluate( q );
    }

    PyObject* m_pyobj;

};

void register_FTDecayFunction1DGauss_class(){

    { //::FTDecayFunction1DGauss
        typedef bp::class_< FTDecayFunction1DGauss_wrapper, bp::bases< IFTDecayFunction1D >, std::auto_ptr< FTDecayFunction1DGauss_wrapper > > FTDecayFunction1DGauss_exposer_t;
        FTDecayFunction1DGauss_exposer_t FTDecayFunction1DGauss_exposer = FTDecayFunction1DGauss_exposer_t( "FTDecayFunction1DGauss", "1 dimensional Gauss decay function in reciprocal space.", bp::init< double >(( bp::arg("omega") )) );
        bp::scope FTDecayFunction1DGauss_scope( FTDecayFunction1DGauss_exposer );
        { //::FTDecayFunction1DGauss::clone
        
            typedef ::FTDecayFunction1DGauss * ( ::FTDecayFunction1DGauss::*clone_function_type)(  ) const;
            typedef ::FTDecayFunction1DGauss * ( FTDecayFunction1DGauss_wrapper::*default_clone_function_type)(  ) const;
            
            FTDecayFunction1DGauss_exposer.def( 
                "clone"
                , clone_function_type(&::FTDecayFunction1DGauss::clone)
                , default_clone_function_type(&FTDecayFunction1DGauss_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDecayFunction1DGauss::evaluate
        
            typedef double ( ::FTDecayFunction1DGauss::*evaluate_function_type)( double ) const;
            typedef double ( FTDecayFunction1DGauss_wrapper::*default_evaluate_function_type)( double ) const;
            
            FTDecayFunction1DGauss_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDecayFunction1DGauss::evaluate)
                , default_evaluate_function_type(&FTDecayFunction1DGauss_wrapper::default_evaluate)
                , ( bp::arg("q") ) );
        
        }
    }

}
