// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDistribution1DTriangle.pypp.h"

namespace bp = boost::python;

struct FTDistribution1DTriangle_wrapper : FTDistribution1DTriangle, bp::wrapper< FTDistribution1DTriangle > {

    FTDistribution1DTriangle_wrapper(FTDistribution1DTriangle const & arg )
    : FTDistribution1DTriangle( arg )
      , bp::wrapper< FTDistribution1DTriangle >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDistribution1DTriangle_wrapper(double omega )
    : FTDistribution1DTriangle( omega )
      , bp::wrapper< FTDistribution1DTriangle >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDistribution1DTriangle * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDistribution1DTriangle::clone(  );
        }
    }
    
    ::FTDistribution1DTriangle * default_clone(  ) const  {
        return FTDistribution1DTriangle::clone( );
    }

    virtual double evaluate( double q ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( q );
        else{
            return this->FTDistribution1DTriangle::evaluate( q );
        }
    }
    
    double default_evaluate( double q ) const  {
        return FTDistribution1DTriangle::evaluate( q );
    }

    PyObject* m_pyobj;

};

void register_FTDistribution1DTriangle_class(){

    { //::FTDistribution1DTriangle
        typedef bp::class_< FTDistribution1DTriangle_wrapper, bp::bases< IFTDistribution1D >, std::auto_ptr< FTDistribution1DTriangle_wrapper > > FTDistribution1DTriangle_exposer_t;
        FTDistribution1DTriangle_exposer_t FTDistribution1DTriangle_exposer = FTDistribution1DTriangle_exposer_t( "FTDistribution1DTriangle", "1 dimensional triangle distribution in Fourier space.", bp::init< double >(( bp::arg("omega") )) );
        bp::scope FTDistribution1DTriangle_scope( FTDistribution1DTriangle_exposer );
        { //::FTDistribution1DTriangle::clone
        
            typedef ::FTDistribution1DTriangle * ( ::FTDistribution1DTriangle::*clone_function_type)(  ) const;
            typedef ::FTDistribution1DTriangle * ( FTDistribution1DTriangle_wrapper::*default_clone_function_type)(  ) const;
            
            FTDistribution1DTriangle_exposer.def( 
                "clone"
                , clone_function_type(&::FTDistribution1DTriangle::clone)
                , default_clone_function_type(&FTDistribution1DTriangle_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDistribution1DTriangle::evaluate
        
            typedef double ( ::FTDistribution1DTriangle::*evaluate_function_type)( double ) const;
            typedef double ( FTDistribution1DTriangle_wrapper::*default_evaluate_function_type)( double ) const;
            
            FTDistribution1DTriangle_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDistribution1DTriangle::evaluate)
                , default_evaluate_function_type(&FTDistribution1DTriangle_wrapper::default_evaluate)
                , ( bp::arg("q") ) );
        
        }
    }

}
