// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDistribution1DVoigt.pypp.h"

namespace bp = boost::python;

struct FTDistribution1DVoigt_wrapper : FTDistribution1DVoigt, bp::wrapper< FTDistribution1DVoigt > {

    FTDistribution1DVoigt_wrapper(FTDistribution1DVoigt const & arg )
    : FTDistribution1DVoigt( arg )
      , bp::wrapper< FTDistribution1DVoigt >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDistribution1DVoigt_wrapper(double omega, double eta )
    : FTDistribution1DVoigt( omega, eta )
      , bp::wrapper< FTDistribution1DVoigt >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDistribution1DVoigt * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDistribution1DVoigt::clone(  );
        }
    }
    
    ::FTDistribution1DVoigt * default_clone(  ) const  {
        return FTDistribution1DVoigt::clone( );
    }

    virtual double evaluate( double q ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( q );
        else{
            return this->FTDistribution1DVoigt::evaluate( q );
        }
    }
    
    double default_evaluate( double q ) const  {
        return FTDistribution1DVoigt::evaluate( q );
    }

    virtual double getEta(  ) const  {
        if( bp::override func_getEta = this->get_override( "getEta" ) )
            return func_getEta(  );
        else{
            return this->FTDistribution1DVoigt::getEta(  );
        }
    }
    
    double default_getEta(  ) const  {
        return FTDistribution1DVoigt::getEta( );
    }

    PyObject* m_pyobj;

};

void register_FTDistribution1DVoigt_class(){

    { //::FTDistribution1DVoigt
        typedef bp::class_< FTDistribution1DVoigt_wrapper, bp::bases< IFTDistribution1D >, std::auto_ptr< FTDistribution1DVoigt_wrapper > > FTDistribution1DVoigt_exposer_t;
        FTDistribution1DVoigt_exposer_t FTDistribution1DVoigt_exposer = FTDistribution1DVoigt_exposer_t( "FTDistribution1DVoigt", "1 dimensional Voigt distribution in Fourier space.", bp::init< double, double >(( bp::arg("omega"), bp::arg("eta") )) );
        bp::scope FTDistribution1DVoigt_scope( FTDistribution1DVoigt_exposer );
        { //::FTDistribution1DVoigt::clone
        
            typedef ::FTDistribution1DVoigt * ( ::FTDistribution1DVoigt::*clone_function_type)(  ) const;
            typedef ::FTDistribution1DVoigt * ( FTDistribution1DVoigt_wrapper::*default_clone_function_type)(  ) const;
            
            FTDistribution1DVoigt_exposer.def( 
                "clone"
                , clone_function_type(&::FTDistribution1DVoigt::clone)
                , default_clone_function_type(&FTDistribution1DVoigt_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDistribution1DVoigt::evaluate
        
            typedef double ( ::FTDistribution1DVoigt::*evaluate_function_type)( double ) const;
            typedef double ( FTDistribution1DVoigt_wrapper::*default_evaluate_function_type)( double ) const;
            
            FTDistribution1DVoigt_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDistribution1DVoigt::evaluate)
                , default_evaluate_function_type(&FTDistribution1DVoigt_wrapper::default_evaluate)
                , ( bp::arg("q") ) );
        
        }
        { //::FTDistribution1DVoigt::getEta
        
            typedef double ( ::FTDistribution1DVoigt::*getEta_function_type)(  ) const;
            typedef double ( FTDistribution1DVoigt_wrapper::*default_getEta_function_type)(  ) const;
            
            FTDistribution1DVoigt_exposer.def( 
                "getEta"
                , getEta_function_type(&::FTDistribution1DVoigt::getEta)
                , default_getEta_function_type(&FTDistribution1DVoigt_wrapper::default_getEta) );
        
        }
    }

}
