// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "HomogeneousMagneticMaterial.pypp.h"

namespace bp = boost::python;

struct HomogeneousMagneticMaterial_wrapper : HomogeneousMagneticMaterial, bp::wrapper< HomogeneousMagneticMaterial > {

    HomogeneousMagneticMaterial_wrapper(HomogeneousMagneticMaterial const & arg )
    : HomogeneousMagneticMaterial( arg )
      , bp::wrapper< HomogeneousMagneticMaterial >(){
        // copy constructor
        m_pyobj = 0;
    }

    HomogeneousMagneticMaterial_wrapper(::std::string const & name, ::complex_t const & refractive_index, ::kvector_t const & magnetic_field )
    : HomogeneousMagneticMaterial( name, boost::ref(refractive_index), boost::ref(magnetic_field) )
      , bp::wrapper< HomogeneousMagneticMaterial >(){
        // constructor
    m_pyobj = 0;
    }

    HomogeneousMagneticMaterial_wrapper(::std::string const & name, double refractive_index_delta, double refractive_index_beta, ::kvector_t const & magnetic_field )
    : HomogeneousMagneticMaterial( name, refractive_index_delta, refractive_index_beta, boost::ref(magnetic_field) )
      , bp::wrapper< HomogeneousMagneticMaterial >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::HomogeneousMagneticMaterial * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->HomogeneousMagneticMaterial::clone(  );
        }
    }
    
    ::HomogeneousMagneticMaterial * default_clone(  ) const  {
        return HomogeneousMagneticMaterial::clone( );
    }

    virtual ::IMaterial const * createTransformedMaterial( ::IRotation const & rotation ) const  {
        if( bp::override func_createTransformedMaterial = this->get_override( "createTransformedMaterial" ) )
            return func_createTransformedMaterial( boost::ref(rotation) );
        else{
            return this->HomogeneousMagneticMaterial::createTransformedMaterial( boost::ref(rotation) );
        }
    }
    
    ::IMaterial const * default_createTransformedMaterial( ::IRotation const & rotation ) const  {
        return HomogeneousMagneticMaterial::createTransformedMaterial( boost::ref(rotation) );
    }

    virtual bool isScalarMaterial(  ) const  {
        if( bp::override func_isScalarMaterial = this->get_override( "isScalarMaterial" ) )
            return func_isScalarMaterial(  );
        else{
            return this->HomogeneousMagneticMaterial::isScalarMaterial(  );
        }
    }
    
    bool default_isScalarMaterial(  ) const  {
        return HomogeneousMagneticMaterial::isScalarMaterial( );
    }

    virtual ::complex_t getRefractiveIndex(  ) const  {
        if( bp::override func_getRefractiveIndex = this->get_override( "getRefractiveIndex" ) )
            return func_getRefractiveIndex(  );
        else{
            return this->HomogeneousMaterial::getRefractiveIndex(  );
        }
    }
    
    ::complex_t default_getRefractiveIndex(  ) const  {
        return HomogeneousMaterial::getRefractiveIndex( );
    }

    PyObject* m_pyobj;

};

void register_HomogeneousMagneticMaterial_class(){

    { //::HomogeneousMagneticMaterial
        typedef bp::class_< HomogeneousMagneticMaterial_wrapper, bp::bases< HomogeneousMaterial >, std::auto_ptr< HomogeneousMagneticMaterial_wrapper > > HomogeneousMagneticMaterial_exposer_t;
        HomogeneousMagneticMaterial_exposer_t HomogeneousMagneticMaterial_exposer = HomogeneousMagneticMaterial_exposer_t( "HomogeneousMagneticMaterial", "An homogeneous material with magnetization.", bp::init< std::string const &, complex_t const &, kvector_t const & >(( bp::arg("name"), bp::arg("refractive_index"), bp::arg("magnetic_field") ), "Constructs a material with _name_, _refractive_index_ and _magnetic_field_ ") );
        bp::scope HomogeneousMagneticMaterial_scope( HomogeneousMagneticMaterial_exposer );
        HomogeneousMagneticMaterial_exposer.def( bp::init< std::string const &, double, double, kvector_t const & >(( bp::arg("name"), bp::arg("refractive_index_delta"), bp::arg("refractive_index_beta"), bp::arg("magnetic_field") ), "Constructs a material with _name_, refractive_index parameters and _magnetic_field_ ") );
        { //::HomogeneousMagneticMaterial::clone
        
            typedef ::HomogeneousMagneticMaterial * ( ::HomogeneousMagneticMaterial::*clone_function_type)(  ) const;
            typedef ::HomogeneousMagneticMaterial * ( HomogeneousMagneticMaterial_wrapper::*default_clone_function_type)(  ) const;
            
            HomogeneousMagneticMaterial_exposer.def( 
                "clone"
                , clone_function_type(&::HomogeneousMagneticMaterial::clone)
                , default_clone_function_type(&HomogeneousMagneticMaterial_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::HomogeneousMagneticMaterial::createTransformedMaterial
        
            typedef ::IMaterial const * ( ::HomogeneousMagneticMaterial::*createTransformedMaterial_function_type)( ::IRotation const & ) const;
            typedef ::IMaterial const * ( HomogeneousMagneticMaterial_wrapper::*default_createTransformedMaterial_function_type)( ::IRotation const & ) const;
            
            HomogeneousMagneticMaterial_exposer.def( 
                "createTransformedMaterial"
                , createTransformedMaterial_function_type(&::HomogeneousMagneticMaterial::createTransformedMaterial)
                , default_createTransformedMaterial_function_type(&HomogeneousMagneticMaterial_wrapper::default_createTransformedMaterial)
                , ( bp::arg("rotation") )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::HomogeneousMagneticMaterial::getMagneticField
        
            typedef ::kvector_t ( ::HomogeneousMagneticMaterial::*getMagneticField_function_type)(  ) const;
            
            HomogeneousMagneticMaterial_exposer.def( 
                "getMagneticField"
                , getMagneticField_function_type( &::HomogeneousMagneticMaterial::getMagneticField )
                , "Get the magnetic field (in Tesla)." );
        
        }
        { //::HomogeneousMagneticMaterial::isScalarMaterial
        
            typedef bool ( ::HomogeneousMagneticMaterial::*isScalarMaterial_function_type)(  ) const;
            typedef bool ( HomogeneousMagneticMaterial_wrapper::*default_isScalarMaterial_function_type)(  ) const;
            
            HomogeneousMagneticMaterial_exposer.def( 
                "isScalarMaterial"
                , isScalarMaterial_function_type(&::HomogeneousMagneticMaterial::isScalarMaterial)
                , default_isScalarMaterial_function_type(&HomogeneousMagneticMaterial_wrapper::default_isScalarMaterial) );
        
        }
        { //::HomogeneousMagneticMaterial::setMagneticField
        
            typedef void ( ::HomogeneousMagneticMaterial::*setMagneticField_function_type)( ::kvector_t const & ) ;
            
            HomogeneousMagneticMaterial_exposer.def( 
                "setMagneticField"
                , setMagneticField_function_type( &::HomogeneousMagneticMaterial::setMagneticField )
                , ( bp::arg("magnetic_field") )
                , "Set the magnetic field (in Tesla)." );
        
        }
        { //::HomogeneousMaterial::getRefractiveIndex
        
            typedef ::complex_t ( ::HomogeneousMaterial::*getRefractiveIndex_function_type)(  ) const;
            typedef ::complex_t ( HomogeneousMagneticMaterial_wrapper::*default_getRefractiveIndex_function_type)(  ) const;
            
            HomogeneousMagneticMaterial_exposer.def( 
                "getRefractiveIndex"
                , getRefractiveIndex_function_type(&::HomogeneousMaterial::getRefractiveIndex)
                , default_getRefractiveIndex_function_type(&HomogeneousMagneticMaterial_wrapper::default_getRefractiveIndex) );
        
        }
    }

}
