// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "HorizontalLine.pypp.h"

namespace bp = boost::python;

struct HorizontalLine_wrapper : Geometry::HorizontalLine, bp::wrapper< Geometry::HorizontalLine > {

    HorizontalLine_wrapper(double y )
    : Geometry::HorizontalLine( y )
      , bp::wrapper< Geometry::HorizontalLine >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::Geometry::HorizontalLine * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->Geometry::HorizontalLine::clone(  );
        }
    }
    
    ::Geometry::HorizontalLine * default_clone(  ) const  {
        return Geometry::HorizontalLine::clone( );
    }

    virtual bool contains( double x, double y ) const  {
        if( bp::override func_contains = this->get_override( "contains" ) )
            return func_contains( x, y );
        else{
            return this->Geometry::HorizontalLine::contains( x, y );
        }
    }
    
    bool default_contains( double x, double y ) const  {
        return Geometry::HorizontalLine::contains( x, y );
    }

    virtual bool contains( ::Bin1D const & binx, ::Bin1D const & biny ) const  {
        if( bp::override func_contains = this->get_override( "contains" ) )
            return func_contains( boost::ref(binx), boost::ref(biny) );
        else{
            return this->Geometry::HorizontalLine::contains( boost::ref(binx), boost::ref(biny) );
        }
    }
    
    bool default_contains( ::Bin1D const & binx, ::Bin1D const & biny ) const  {
        return Geometry::HorizontalLine::contains( boost::ref(binx), boost::ref(biny) );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_HorizontalLine_class(){

    { //::Geometry::HorizontalLine
        typedef bp::class_< HorizontalLine_wrapper, bp::bases< Geometry::IShape2D >, std::auto_ptr< HorizontalLine_wrapper >, boost::noncopyable > HorizontalLine_exposer_t;
        HorizontalLine_exposer_t HorizontalLine_exposer = HorizontalLine_exposer_t( "HorizontalLine", "Horizontal infinite lin.", bp::init< double >(( bp::arg("y") ), "Infinite vertical line constructor @param y The value at which it crosses y-axes \n\n:Parameters:\n  - 'y' - The value at which it crosses y-axes\n") );
        bp::scope HorizontalLine_scope( HorizontalLine_exposer );
        { //::Geometry::HorizontalLine::clone
        
            typedef ::Geometry::HorizontalLine * ( ::Geometry::HorizontalLine::*clone_function_type)(  ) const;
            typedef ::Geometry::HorizontalLine * ( HorizontalLine_wrapper::*default_clone_function_type)(  ) const;
            
            HorizontalLine_exposer.def( 
                "clone"
                , clone_function_type(&::Geometry::HorizontalLine::clone)
                , default_clone_function_type(&HorizontalLine_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::Geometry::HorizontalLine::contains
        
            typedef bool ( ::Geometry::HorizontalLine::*contains_function_type)( double,double ) const;
            typedef bool ( HorizontalLine_wrapper::*default_contains_function_type)( double,double ) const;
            
            HorizontalLine_exposer.def( 
                "contains"
                , contains_function_type(&::Geometry::HorizontalLine::contains)
                , default_contains_function_type(&HorizontalLine_wrapper::default_contains)
                , ( bp::arg("x"), bp::arg("y") ) );
        
        }
        { //::Geometry::HorizontalLine::contains
        
            typedef bool ( ::Geometry::HorizontalLine::*contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            typedef bool ( HorizontalLine_wrapper::*default_contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            
            HorizontalLine_exposer.def( 
                "contains"
                , contains_function_type(&::Geometry::HorizontalLine::contains)
                , default_contains_function_type(&HorizontalLine_wrapper::default_contains)
                , ( bp::arg("binx"), bp::arg("biny") ) );
        
        }
        { //::Geometry::HorizontalLine::getYpos
        
            typedef double ( ::Geometry::HorizontalLine::*getYpos_function_type)(  ) const;
            
            HorizontalLine_exposer.def( 
                "getYpos"
                , getYpos_function_type( &::Geometry::HorizontalLine::getYpos )
                , "Returns true if the line crosses the area defined by two given bins." );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( HorizontalLine_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            HorizontalLine_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&HorizontalLine_wrapper::default_transferToCPP) );
        
        }
    }

}
