// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IAbstractParticle.pypp.h"

namespace bp = boost::python;

struct IAbstractParticle_wrapper : IAbstractParticle, bp::wrapper< IAbstractParticle > {

    IAbstractParticle_wrapper( )
    : IAbstractParticle( )
      , bp::wrapper< IAbstractParticle >(){
        // null constructor
    m_pyobj = 0;
    }

    virtual ::IAbstractParticle * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual ::IAbstractParticle * cloneInvertB(  ) const {
        bp::override func_cloneInvertB = this->get_override( "cloneInvertB" );
        return func_cloneInvertB(  );
    }

    virtual ::IMaterial const * getAmbientMaterial(  ) const {
        bp::override func_getAmbientMaterial = this->get_override( "getAmbientMaterial" );
        return func_getAmbientMaterial(  );
    }

    virtual void setAmbientMaterial( ::IMaterial const & material ) {
        if( bp::override func_setAmbientMaterial = this->get_override( "setAmbientMaterial" ) )
            func_setAmbientMaterial( boost::ref(material) );
        else{
            this->IAbstractParticle::setAmbientMaterial( boost::ref(material) );
        }
    }
    
    void default_setAmbientMaterial( ::IMaterial const & material ) {
        IAbstractParticle::setAmbientMaterial( boost::ref(material) );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ICompositeSample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ICompositeSample::getChildren( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ICompositeSample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ICompositeSample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_IAbstractParticle_class(){

    { //::IAbstractParticle
        typedef bp::class_< IAbstractParticle_wrapper, bp::bases< ICompositeSample >, std::auto_ptr< IAbstractParticle_wrapper >, boost::noncopyable > IAbstractParticle_exposer_t;
        IAbstractParticle_exposer_t IAbstractParticle_exposer = IAbstractParticle_exposer_t( "IAbstractParticle", "Interface for a generic particl.", bp::init< >() );
        bp::scope IAbstractParticle_scope( IAbstractParticle_exposer );
        { //::IAbstractParticle::clone
        
            typedef ::IAbstractParticle * ( ::IAbstractParticle::*clone_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::IAbstractParticle::clone) )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IAbstractParticle::cloneInvertB
        
            typedef ::IAbstractParticle * ( ::IAbstractParticle::*cloneInvertB_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "cloneInvertB"
                , bp::pure_virtual( cloneInvertB_function_type(&::IAbstractParticle::cloneInvertB) )
                , bp::return_value_policy< bp::reference_existing_object >()
                , "Returns a clone with inverted magnetic fields." );
        
        }
        { //::IAbstractParticle::getAbundance
        
            typedef double ( ::IAbstractParticle::*getAbundance_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "getAbundance"
                , getAbundance_function_type( &::IAbstractParticle::getAbundance ) );
        
        }
        { //::IAbstractParticle::getAmbientMaterial
        
            typedef ::IMaterial const * ( ::IAbstractParticle::*getAmbientMaterial_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "getAmbientMaterial"
                , bp::pure_virtual( getAmbientMaterial_function_type(&::IAbstractParticle::getAmbientMaterial) )
                , bp::return_value_policy< bp::reference_existing_object >()
                , "Returns particle's material." );
        
        }
        { //::IAbstractParticle::setAbundance
        
            typedef void ( ::IAbstractParticle::*setAbundance_function_type)( double ) ;
            
            IAbstractParticle_exposer.def( 
                "setAbundance"
                , setAbundance_function_type( &::IAbstractParticle::setAbundance )
                , ( bp::arg("abundance") ) );
        
        }
        { //::IAbstractParticle::setAmbientMaterial
        
            typedef void ( ::IAbstractParticle::*setAmbientMaterial_function_type)( ::IMaterial const & ) ;
            typedef void ( IAbstractParticle_wrapper::*default_setAmbientMaterial_function_type)( ::IMaterial const & ) ;
            
            IAbstractParticle_exposer.def( 
                "setAmbientMaterial"
                , setAmbientMaterial_function_type(&::IAbstractParticle::setAmbientMaterial)
                , default_setAmbientMaterial_function_type(&IAbstractParticle_wrapper::default_setAmbientMaterial)
                , ( bp::arg("material") ) );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( IAbstractParticle_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&IAbstractParticle_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ICompositeSample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ICompositeSample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( IAbstractParticle_wrapper::*default_getChildren_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ICompositeSample::getChildren)
                , default_getChildren_function_type(&IAbstractParticle_wrapper::default_getChildren) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( IAbstractParticle_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            IAbstractParticle_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&IAbstractParticle_wrapper::default_printSampleTree) );
        
        }
        { //::ICompositeSample::size
        
            typedef ::std::size_t ( ::ICompositeSample::*size_function_type)(  ) const;
            typedef ::std::size_t ( IAbstractParticle_wrapper::*default_size_function_type)(  ) const;
            
            IAbstractParticle_exposer.def( 
                "size"
                , size_function_type(&::ICompositeSample::size)
                , default_size_function_type(&IAbstractParticle_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( IAbstractParticle_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            IAbstractParticle_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&IAbstractParticle_wrapper::default_transferToCPP) );
        
        }
    }

}
