// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IClusteredParticles.pypp.h"

namespace bp = boost::python;

struct IClusteredParticles_wrapper : IClusteredParticles, bp::wrapper< IClusteredParticles > {

    IClusteredParticles_wrapper( )
    : IClusteredParticles( )
      , bp::wrapper< IClusteredParticles >(){
        // null constructor
    m_pyobj = 0;
    }

    virtual void accept( ::ISampleVisitor * visitor ) const {
        bp::override func_accept = this->get_override( "accept" );
        func_accept( boost::python::ptr(visitor) );
    }

    virtual void applyRotation( ::IRotation const & rotation ) {
        if( bp::override func_applyRotation = this->get_override( "applyRotation" ) )
            func_applyRotation( boost::ref(rotation) );
        else{
            this->IClusteredParticles::applyRotation( boost::ref(rotation) );
        }
    }
    
    void default_applyRotation( ::IRotation const & rotation ) {
        IClusteredParticles::applyRotation( boost::ref(rotation) );
    }

    virtual ::IClusteredParticles * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual ::IClusteredParticles * cloneInvertB(  ) const {
        bp::override func_cloneInvertB = this->get_override( "cloneInvertB" );
        return func_cloneInvertB(  );
    }

    virtual ::IMaterial const * getAmbientMaterial(  ) const {
        bp::override func_getAmbientMaterial = this->get_override( "getAmbientMaterial" );
        return func_getAmbientMaterial(  );
    }

    virtual void setAmbientMaterial( ::IMaterial const & material ){
        bp::override func_setAmbientMaterial = this->get_override( "setAmbientMaterial" );
        func_setAmbientMaterial( boost::ref(material) );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ICompositeSample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ICompositeSample::getChildren( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ICompositeSample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ICompositeSample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_IClusteredParticles_class(){

    { //::IClusteredParticles
        typedef bp::class_< IClusteredParticles_wrapper, bp::bases< ICompositeSample >, std::auto_ptr< IClusteredParticles_wrapper >, boost::noncopyable > IClusteredParticles_exposer_t;
        IClusteredParticles_exposer_t IClusteredParticles_exposer = IClusteredParticles_exposer_t( "IClusteredParticles", "An ordered assembly of particle.", bp::init< >() );
        bp::scope IClusteredParticles_scope( IClusteredParticles_exposer );
        { //::IClusteredParticles::accept
        
            typedef void ( ::IClusteredParticles::*accept_function_type)( ::ISampleVisitor * ) const;
            
            IClusteredParticles_exposer.def( 
                "accept"
                , bp::pure_virtual( accept_function_type(&::IClusteredParticles::accept) )
                , ( bp::arg("visitor") )
                , "calls the ISampleVisitor's visit method." );
        
        }
        { //::IClusteredParticles::applyRotation
        
            typedef void ( ::IClusteredParticles::*applyRotation_function_type)( ::IRotation const & ) ;
            typedef void ( IClusteredParticles_wrapper::*default_applyRotation_function_type)( ::IRotation const & ) ;
            
            IClusteredParticles_exposer.def( 
                "applyRotation"
                , applyRotation_function_type(&::IClusteredParticles::applyRotation)
                , default_applyRotation_function_type(&IClusteredParticles_wrapper::default_applyRotation)
                , ( bp::arg("rotation") ) );
        
        }
        { //::IClusteredParticles::clone
        
            typedef ::IClusteredParticles * ( ::IClusteredParticles::*clone_function_type)(  ) const;
            
            IClusteredParticles_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::IClusteredParticles::clone) )
                , bp::return_value_policy< bp::manage_new_object >()
                , "clone method to allow for polymorphic copying." );
        
        }
        { //::IClusteredParticles::cloneInvertB
        
            typedef ::IClusteredParticles * ( ::IClusteredParticles::*cloneInvertB_function_type)(  ) const;
            
            IClusteredParticles_exposer.def( 
                "cloneInvertB"
                , bp::pure_virtual( cloneInvertB_function_type(&::IClusteredParticles::cloneInvertB) )
                , bp::return_value_policy< bp::reference_existing_object >()
                , "Returns a clone with inverted magnetic fields." );
        
        }
        { //::IClusteredParticles::getAmbientMaterial
        
            typedef ::IMaterial const * ( ::IClusteredParticles::*getAmbientMaterial_function_type)(  ) const;
            
            IClusteredParticles_exposer.def( 
                "getAmbientMaterial"
                , bp::pure_virtual( getAmbientMaterial_function_type(&::IClusteredParticles::getAmbientMaterial) )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::IClusteredParticles::setAmbientMaterial
        
            typedef void ( ::IClusteredParticles::*setAmbientMaterial_function_type)( ::IMaterial const & ) ;
            
            IClusteredParticles_exposer.def( 
                "setAmbientMaterial"
                , bp::pure_virtual( setAmbientMaterial_function_type(&::IClusteredParticles::setAmbientMaterial) )
                , ( bp::arg("material") )
                , "calls the ISampleVisitor's visit method." );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( IClusteredParticles_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            IClusteredParticles_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&IClusteredParticles_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ICompositeSample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ICompositeSample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( IClusteredParticles_wrapper::*default_getChildren_function_type)(  ) const;
            
            IClusteredParticles_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ICompositeSample::getChildren)
                , default_getChildren_function_type(&IClusteredParticles_wrapper::default_getChildren) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( IClusteredParticles_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            IClusteredParticles_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&IClusteredParticles_wrapper::default_printSampleTree) );
        
        }
        { //::ICompositeSample::size
        
            typedef ::std::size_t ( ::ICompositeSample::*size_function_type)(  ) const;
            typedef ::std::size_t ( IClusteredParticles_wrapper::*default_size_function_type)(  ) const;
            
            IClusteredParticles_exposer.def( 
                "size"
                , size_function_type(&::ICompositeSample::size)
                , default_size_function_type(&IClusteredParticles_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( IClusteredParticles_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            IClusteredParticles_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&IClusteredParticles_wrapper::default_transferToCPP) );
        
        }
    }

}
