// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "ICompositeSample.pypp.h"

namespace bp = boost::python;

struct ICompositeSample_wrapper : ICompositeSample, bp::wrapper< ICompositeSample > {

    ICompositeSample_wrapper( )
    : ICompositeSample( )
      , bp::wrapper< ICompositeSample >(){
        // null constructor
    m_pyobj = 0;
    }

    virtual ::ICompositeSample * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ICompositeSample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ICompositeSample::getChildren( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ICompositeSample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ICompositeSample::size( );
    }

    virtual ::ISample * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->ISample::cloneInvertB(  );
        }
    }
    
    ::ISample * default_cloneInvertB(  ) const  {
        return ISample::cloneInvertB( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_ICompositeSample_class(){

    { //::ICompositeSample
        typedef bp::class_< ICompositeSample_wrapper, bp::bases< ISample >, std::auto_ptr< ICompositeSample_wrapper >, boost::noncopyable > ICompositeSample_exposer_t;
        ICompositeSample_exposer_t ICompositeSample_exposer = ICompositeSample_exposer_t( "ICompositeSample", "Interface to describe the tree-like composition of sample.", bp::init< >() );
        bp::scope ICompositeSample_scope( ICompositeSample_exposer );
        { //::ICompositeSample::clone
        
            typedef ::ICompositeSample * ( ::ICompositeSample::*clone_function_type)(  ) const;
            
            ICompositeSample_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::ICompositeSample::clone) )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::ICompositeSample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ICompositeSample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( ICompositeSample_wrapper::*default_getChildren_function_type)(  ) const;
            
            ICompositeSample_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ICompositeSample::getChildren)
                , default_getChildren_function_type(&ICompositeSample_wrapper::default_getChildren) );
        
        }
        { //::ICompositeSample::operator[]
        
            typedef ::ISample * ( ::ICompositeSample::*__getitem___function_type)( ::std::size_t ) ;
            
            ICompositeSample_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::ICompositeSample::operator[] )
                , ( bp::arg("index") )
                , bp::return_internal_reference< >()
                , "Returns child pointer by index (with range checking)." );
        
        }
        { //::ICompositeSample::operator[]
        
            typedef ::ISample const * ( ::ICompositeSample::*__getitem___function_type)( ::std::size_t ) const;
            
            ICompositeSample_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::ICompositeSample::operator[] )
                , ( bp::arg("index") )
                , bp::return_internal_reference< >()
                , "Returns child pointer by index (with range checking)." );
        
        }
        { //::ICompositeSample::size
        
            typedef ::std::size_t ( ::ICompositeSample::*size_function_type)(  ) const;
            typedef ::std::size_t ( ICompositeSample_wrapper::*default_size_function_type)(  ) const;
            
            ICompositeSample_exposer.def( 
                "size"
                , size_function_type(&::ICompositeSample::size)
                , default_size_function_type(&ICompositeSample_wrapper::default_size) );
        
        }
        { //::ISample::cloneInvertB
        
            typedef ::ISample * ( ::ISample::*cloneInvertB_function_type)(  ) const;
            typedef ::ISample * ( ICompositeSample_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            ICompositeSample_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::ISample::cloneInvertB)
                , default_cloneInvertB_function_type(&ICompositeSample_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( ICompositeSample_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            ICompositeSample_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&ICompositeSample_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( ICompositeSample_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            ICompositeSample_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&ICompositeSample_wrapper::default_printSampleTree) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( ICompositeSample_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            ICompositeSample_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&ICompositeSample_wrapper::default_transferToCPP) );
        
        }
    }

}
