// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonFitList.h"
#include "FitStrategyFixParameters.pypp.h"

namespace bp = boost::python;

struct FitStrategyFixParameters_wrapper : FitStrategyFixParameters, bp::wrapper< FitStrategyFixParameters > {

    FitStrategyFixParameters_wrapper(FitStrategyFixParameters const & arg )
    : FitStrategyFixParameters( arg )
      , bp::wrapper< FitStrategyFixParameters >(){
        // copy constructor
        m_pyobj = 0;
    }

    FitStrategyFixParameters_wrapper( )
    : FitStrategyFixParameters( )
      , bp::wrapper< FitStrategyFixParameters >(){
        // null constructor
    m_pyobj = 0;
    }

    FitStrategyFixParameters_wrapper(::std::vector< std::string > const & pars )
    : FitStrategyFixParameters( boost::ref(pars) )
      , bp::wrapper< FitStrategyFixParameters >(){
        // constructor
    m_pyobj = 0;
    }

    virtual void clear(  ) {
        if( bp::override func_clear = this->get_override( "clear" ) )
            func_clear(  );
        else{
            this->FitStrategyFixParameters::clear(  );
        }
    }
    
    void default_clear(  ) {
        FitStrategyFixParameters::clear( );
    }

    virtual ::FitStrategyFixParameters * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FitStrategyFixParameters::clone(  );
        }
    }
    
    ::FitStrategyFixParameters * default_clone(  ) const  {
        return FitStrategyFixParameters::clone( );
    }

    virtual void setFixed( ::std::vector< std::string > const & pars ) {
        if( bp::override func_setFixed = this->get_override( "setFixed" ) )
            func_setFixed( boost::ref(pars) );
        else{
            this->FitStrategyFixParameters::setFixed( boost::ref(pars) );
        }
    }
    
    void default_setFixed( ::std::vector< std::string > const & pars ) {
        FitStrategyFixParameters::setFixed( boost::ref(pars) );
    }

    virtual void execute(  ) {
        if( bp::override func_execute = this->get_override( "execute" ) )
            func_execute(  );
        else{
            this->FitStrategyAdjustParameters::execute(  );
        }
    }
    
    void default_execute(  ) {
        FitStrategyAdjustParameters::execute( );
    }

    virtual void setPreserveOriginalValues( bool preserve_values ) {
        if( bp::override func_setPreserveOriginalValues = this->get_override( "setPreserveOriginalValues" ) )
            func_setPreserveOriginalValues( preserve_values );
        else{
            this->FitStrategyAdjustParameters::setPreserveOriginalValues( preserve_values );
        }
    }
    
    void default_setPreserveOriginalValues( bool preserve_values ) {
        FitStrategyAdjustParameters::setPreserveOriginalValues( preserve_values );
    }

    PyObject* m_pyobj;

};

void register_FitStrategyFixParameters_class(){

    { //::FitStrategyFixParameters
        typedef bp::class_< FitStrategyFixParameters_wrapper, bp::bases< FitStrategyAdjustParameters >, std::auto_ptr< FitStrategyFixParameters_wrapper > > FitStrategyFixParameters_exposer_t;
        FitStrategyFixParameters_exposer_t FitStrategyFixParameters_exposer = FitStrategyFixParameters_exposer_t( "FitStrategyFixParameters", "Strategy which fixes certain fit parameters leaving other release.", bp::init< >() );
        bp::scope FitStrategyFixParameters_scope( FitStrategyFixParameters_exposer );
        FitStrategyFixParameters_exposer.def( bp::init< std::vector< std::string > const & >(( bp::arg("pars") )) );
        { //::FitStrategyFixParameters::clear
        
            typedef void ( ::FitStrategyFixParameters::*clear_function_type)(  ) ;
            typedef void ( FitStrategyFixParameters_wrapper::*default_clear_function_type)(  ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "clear"
                , clear_function_type(&::FitStrategyFixParameters::clear)
                , default_clear_function_type(&FitStrategyFixParameters_wrapper::default_clear) );
        
        }
        { //::FitStrategyFixParameters::clone
        
            typedef ::FitStrategyFixParameters * ( ::FitStrategyFixParameters::*clone_function_type)(  ) const;
            typedef ::FitStrategyFixParameters * ( FitStrategyFixParameters_wrapper::*default_clone_function_type)(  ) const;
            
            FitStrategyFixParameters_exposer.def( 
                "clone"
                , clone_function_type(&::FitStrategyFixParameters::clone)
                , default_clone_function_type(&FitStrategyFixParameters_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FitStrategyFixParameters::setFixed
        
            typedef void ( ::FitStrategyFixParameters::*setFixed_function_type)( ::std::vector< std::string > const & ) ;
            typedef void ( FitStrategyFixParameters_wrapper::*default_setFixed_function_type)( ::std::vector< std::string > const & ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "setFixed"
                , setFixed_function_type(&::FitStrategyFixParameters::setFixed)
                , default_setFixed_function_type(&FitStrategyFixParameters_wrapper::default_setFixed)
                , ( bp::arg("pars") ) );
        
        }
        { //::FitStrategyAdjustParameters::execute
        
            typedef void ( ::FitStrategyAdjustParameters::*execute_function_type)(  ) ;
            typedef void ( FitStrategyFixParameters_wrapper::*default_execute_function_type)(  ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "execute"
                , execute_function_type(&::FitStrategyAdjustParameters::execute)
                , default_execute_function_type(&FitStrategyFixParameters_wrapper::default_execute) );
        
        }
        { //::FitStrategyAdjustParameters::fix
        
            typedef ::FitStrategyAdjustParameters & ( ::FitStrategyAdjustParameters::*fix_function_type)( ::std::string ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "fix"
                , fix_function_type(&::FitStrategyAdjustParameters::fix)
                , ( bp::arg("parname") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::FitStrategyAdjustParameters::fix_all
        
            typedef ::FitStrategyAdjustParameters & ( ::FitStrategyAdjustParameters::*fix_all_function_type)(  ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "fix_all"
                , fix_all_function_type(&::FitStrategyAdjustParameters::fix_all)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::FitStrategyAdjustParameters::release
        
            typedef ::FitStrategyAdjustParameters & ( ::FitStrategyAdjustParameters::*release_function_type)( ::std::string ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "release"
                , release_function_type(&::FitStrategyAdjustParameters::release)
                , ( bp::arg("parname") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::FitStrategyAdjustParameters::release_all
        
            typedef ::FitStrategyAdjustParameters & ( ::FitStrategyAdjustParameters::*release_all_function_type)(  ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "release_all"
                , release_all_function_type(&::FitStrategyAdjustParameters::release_all)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::FitStrategyAdjustParameters::setPreserveOriginalValues
        
            typedef void ( ::FitStrategyAdjustParameters::*setPreserveOriginalValues_function_type)( bool ) ;
            typedef void ( FitStrategyFixParameters_wrapper::*default_setPreserveOriginalValues_function_type)( bool ) ;
            
            FitStrategyFixParameters_exposer.def( 
                "setPreserveOriginalValues"
                , setPreserveOriginalValues_function_type(&::FitStrategyAdjustParameters::setPreserveOriginalValues)
                , default_setPreserveOriginalValues_function_type(&FitStrategyFixParameters_wrapper::default_setPreserveOriginalValues)
                , ( bp::arg("preserve_values") ) );
        
        }
    }

}
